if (navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1) {
	console.log("Android Js Bridge Version:0.1.11");
    (function () {
        if (window._androidBridge) {
            return;
        }

        function obj2str(o) {
            var r = [];
            dLog('obj2str:typeof' + typeof o);
            if (typeof o === 'string') {
                return '"' + o.replace(/([\'\"\\])/g, '\\$1').replace(/(\n)/g, '\\n').replace(/(\r)/g, '\\r').replace(/(\t)/g, '\\t') + '"';
            }
            if (typeof o === 'undefined') {
                return 'undefined';
            }
            if (typeof o === 'object') {
                if (o === null) {
                    return 'null';
                } else if (!o.sort) {
                    for (var i in o) {
                        r.push('"' + i + '"' + ':' + obj2str(o[i]));
                    }
                    r = '{' + r.join() + '}';
                } else {
                    for (var i = 0; i < o.length; i++) {
                        r.push(obj2str(o[i]));
                    }
                    r = '[' + r.join() + ']';
                }
                dLog('obj2str:result | ' + r);
                return r;
            }
            dLog('obj2str:result | ' + o.toString());
            return o.toString();
        }

        var messagingIframe;
        var requestMap = {};

        function sendMessage(isAsync, message, callback) {
            dLog('sendMessage isAsync：' + isAsync + ',message:' + message + ',callback:' + callback);
            var key = genJsId();
            if (isAsync) {
                requestMap[key] = {
                    message: message,
                    callback: callback,
                };
                var data = {};
                data[key] = message;

                prompt(obj2str(data).replace(":undefined",":null"));
            } else {
                var response = prompt('jscb_sync' + ':' + obj2str(message).replace(":undefined",":null"));
                if(response.indexOf("DM_BRIDGE_ERROR") !== -1){
                    console.error(response);
                }
                if(response.startsWith("DMALL_TYPE[STRING]")){
                    response = response.replace("DMALL_TYPE[STRING]","");//String
                }else{
                    try{
                        response = JSON.parse(response);//Object
                    }catch(e){

                    }
                }
                
				dLog(response);
                if (callback !== undefined) {
                    callback(response);
                }
                return response;
            }
        }
        window._sendMessage = sendMessage;
        var uniqueId = 1;

        function onJsCallback(message) {
            //message = decodeURIComponent(message);
            dLog('onJsCallback:' + message);
            var data = JSON.parse(message);
            for (var key in data) {
                dLog('key:' + key);
                var value = requestMap[key];
				dLog('value:' + JSON.stringify(value));
                dLog('value.callback:' + JSON.stringify(value.callback));
                if (value.callback !== undefined) {
                    dLog('data[key]:' + data[key]);
                    value.callback(JSON.parse(JSON.parse(data[key])));
                    dLog('callback:' + value);
                }else{
					dLog('data[key]:' + data[key]);
                     if(data[key].indexOf("{\\\"TAG\\\":\\\"DM_BRIDGE_ERROR\\\",") > -1){
                         console.error(data[key]);
                     }
                }
                delete requestMap[key];
				return;
            }
        }

        function genJsId() {
            return 'jscb_async_' + (uniqueId++) + '_' + new Date().getTime();
        }

        function onJavaRequest(message) {
            dLog('onJavaRequest:' + message);
            var data = JSON.parse(message);
            for (var key in data) {
                var result = eval(data[key]);
                dLog('result:' + result);
                data[key] = result;
                prompt(JSON.stringify(data));
            }
        }


        window._androidBridge = {
            sendMessage: sendMessage,
            onJsCallback: onJsCallback,
            onJavaRequest: onJavaRequest,
        };


        function _createQueueReadyIframe(doc) {
            messagingIframe = doc.createElement('iframe');
            messagingIframe.style.display = 'none';
            doc.documentElement.appendChild(messagingIframe);
        }

        var doc = document;
        _createQueueReadyIframe(doc);
        var readyEvent = doc.createEvent('Events');
        readyEvent.initEvent('_androidBridge');
        readyEvent.bridge = _androidBridge;
        doc.dispatchEvent(readyEvent);
    })();
}