/**
 galleon.Navigator
 galleon.Storage
 galleon.Sys = {
 getInfo : function() {},
 getStacks : function( res ) {
 ['asef','asdf','asdf']
 }
 }
 */


// var galleon = {
// 	Sys : {
// 		getInfo : function() {
// 			return '{version : "3.7.0"}';
// 		}
// 	},
// 	Navigator : {
// 		forward : function( url ) {
// 			console.log( '跳转' +url );
// 		}
// 	}
// };

(function () {
    function parseJSON(str) {
        if (typeof str != 'string') {
            return str;
        }

        try {
            return (new Function('return ' + str + ';'))();
        } catch (e) {
            return {};
        }
    }

    if (typeof window == 'undefined') {
        window = {};
    }

    var handle, _fn,
        sysInfo = galleon && galleon.Sys.getInfo() || '{}';

    sysInfo = parseJSON(sysInfo + ''); // 转字符 hack android bug

    handle = {
        /**
         @url String 处理前url
         @context Object 执行上下文

         返回 pixie:stop 禁止往下执行
         */
        // forward拦截代码
        parseUri: function (uri, context) {
            uri = _fn.parseDShopUri(uri); // 解析dshop相关的规则
            uri = _fn.redirectList(uri); // 跳转重定向
            return uri;
            //return ; //返回 pixie:stop 禁止往下执行
        },

        /**
         @url String 处理前url
         @context Object 执行上下文

         返回 pixie:stop 禁止往下执行
         */
        // 扫码页拦截代码
        parseScanUri: function (uri, context) {
            uri = _fn.parseDShopUri(uri);
            uri = _fn.parseStallPos(uri);//餐食档口收银
            uri = _fn.whiteList(uri); // 处理扫码跳转的白名单
            uri = _fn.parseRNUri(uri); // 解析rn相关的规则
            uri = _fn.baseQrCodeRule(uri); // 通用二维码识别规则
            return uri;
        }
    }


    _fn = {
        baseQrCodeRule: function (uri) {

            uri += '';
            /**
             * rule: https://i.dmall.com/{业务场景}/{小程序代码}/?jumpUrl={跳转链接}&ec={可用平台}
             * enableClient 含义
             1           多点app
             2           微信
             3           支付宝
             4           麦德龙app

             * https://i.dmall.com/bld/main/?jumpUrl=https%3A%2F%2Fsg.dmall.com%2Fqr%2F18f_275d0_d013&ec=2-3
             *
             * */
                // Warning：iOS4.9.6之前版本从storage取出的dmTenantId会带有双引号，兼容老版本，替换掉引号
            var dmTenantId = galleon.Storage.get('dmTenantId').indexOf("\"") > -1 ? galleon.Storage.get('dmTenantId').replace(/\"/g, "") : galleon.Storage.get('dmTenantId');
            dmTenantId = dmTenantId + '';
            // /**
            //  * 1或空 多点app
            //  * 2 麦德龙App
            //  * */
            //
            //
            // switch (dmTenantId) {
            //     case '2':
            //         ecName = '麦德龙App';
            //         break;
            //     case '1':
            //     default:
            //         ecName = '多点App';
            //         break;
            //
            // }
            var resultPath = 'app://DMScanResultPage?scanResult=';

            if (/^http(s)?:\/\/(test)?i.dmall.com\/[a-zA-Z].*\/[a-zA-Z].*\/(index.html)?\?/g.test(uri)) {

                var urlQuery = uri.split('?'),
                    urlParams = urlQuery[1] ? _fn.paramToObj(urlQuery[1]) : {};

                if (urlParams.jumpUrl) {

                    var jumpUrl = decodeURIComponent(urlParams.jumpUrl),
                        ecName = '', ecNameList = [],
                        ecParams = urlParams.ec;

                    var ecArr = ecParams.split('-');

                    ecArr.forEach(function (ec) {
                        switch (ec) {
                            case '1':
                                ecNameList.push('多点App');
                                break;
                            case '2':
                                ecNameList.push('微信');
                                break;
                            case '3':
                                ecNameList.push('支付宝');
                                break;
                            case '4':
                                ecNameList.push('麦德龙App');
                                break;
                            default:
                                break;
                        }
                    });

                    ecName = ecNameList.join("/");
                    if ((dmTenantId === '1' && ecArr.indexOf('1') === -1) ||
                        (dmTenantId === '2' && ecArr.indexOf('4') === -1)) { // 因为dmTenantId为2是麦德龙App，但是ec里4才是麦德龙...

                        galleon.Navigator.forward(resultPath + encodeURIComponent('请使用' + ecName +'扫描二维码完成支付'),'');
                        return 'pixie:stop';
                    } else {
                        return jumpUrl;
                    }
                }
            }

            return uri;
        },
        whiteList: function (uri) {
            uri = uri + '';
            if (uri.indexOf('.lsh123.com') > 0) { //放行链家的域
                galleon.Navigator.forward(uri, '');
                return 'pixie:stop';
            } else if (uri.indexOf('.wumart.com') > 0) {
                galleon.Navigator.forward(uri, '');
                return 'pixie:stop';
            } else if (uri.indexOf('.dmall.com/dac/card-binding/guideApp.html') > 0) { //匹配 guideApp 规则
                galleon.Navigator.forward(uri, '');
                return 'pixie:stop';
            //    开为页面白名单
            }else if (uri.indexOf('kiwiar.com/crm/')>-1){
                var _final = uri.indexOf('?') > -1 ? uri + '&dmNeedAuth=true' : uri+'?dmNeedAuth=true';
                galleon.Navigator.forward(_final, '');
                return 'pixie:stop';
            }else if (uri.indexOf('html.starfarm.com.cn/')>-1){
                galleon.Navigator.forward(uri, '');
                return 'pixie:stop';
            }
            return uri;
        },
        redirectList: function (uri) { //跳转重定向
            uri = uri + '';
            if (uri.indexOf('app://DMConnectServicePage') > -1) { //客服老地址跳转 重定向
                galleon.Navigator.forward('http://static.dmall.com/kayak-project/hybridPages/html/support/support.html?dmShowCart=false&dmNeedLogin=true', '');
                return 'pixie:stop';
            //    看点离线化
            } else if (uri.indexOf("//static.dmall.com/kayak-project/highLight/html/highLight.html") > -1) {
                var nUri = uri.replace("//static.dmall.com/kayak-project/highLight/html/highLight.html", "//nstatic.dmall.com/kayak-project/highLight/html/highLight.html")
                if (nUri.indexOf("?dmUseUIWebView=true&") < 0) {
                    return nUri.replace("?", "?dmUseUIWebView=true&");
                } else {
                    return nUri;
                }
            // 智能派样机离线化
            } else if (uri.indexOf("//static.dmall.com/kayak-project/hybridPages/html/sampleMachine/sampleMachine.html") > -1) {
                var nUri = uri.replace("//static.dmall.com/kayak-project/hybridPages/html/sampleMachine/sampleMachine.html", "//nstatic.dmall.com/kayak-project/hybridPages/html/sampleMachine/sampleMachine.html");
                if (nUri.indexOf("?dmUseUIWebView=true&") < 0) {
                    return nUri.replace("?", "?dmUseUIWebView=true&");
                } else {
                    return nUri;
                }
            }
            return uri;
        },
        // http://stallpos.wumart.com/stall/redirec?stallNo=2&orgNo=1163&regionNo=300
        // http://stallpos.wumart.com/hairCut/redirec?orgNo=1606&regionNo=300
        //餐食档口收银
        parseStallPos: function (uri) {
            var scanCode;
            var env = _fn.getENV(uri);
            scanCode = uri.split('?')[1] || '';
            scanCode = scanCode.split('#')[0] || '';
            if (_fn.isStallPos(uri)) {
                var stallCode = _fn.getStallCode(uri, {
                    scanCode: scanCode
                });
                var paramStr = _fn.parseParam(stallCode, '&') || '';
                var receiptUrl = 'static.dmall.com/kayak-project/mpactivities/html/receipt/receipt.html?dmShowShare=false&dmShowCart=false'
                galleon.Navigator.forward(env + receiptUrl + paramStr, '');
                return 'pixie:stop';
            }
            return uri;
        },
        parseDShopUri: function (uri) {
            var result,
                param;

            if (uri.indexOf('a.dmall.com') < 0 && uri.indexOf('static.dmall.com') < 0 && uri.indexOf('static.dmall.com/mini') < 0) {
                return uri; // 非dshop链接不处理
            }

            param = uri.split('?')[1] || '';
            param = param.split('#')[0] || '';
            param = _fn.paramToObj(param);
            var env = _fn.getENV(uri);
            var smartcartUrl = 'static.dmall.com/kayak-project/h5/html/2017/smartcart.html?hideCustomNavigationBar=yes&hideCustomNavigationBar=true&dmShowShare=false&dmShowCart=false&';
            if (_fn.isCoudan(uri, param)) { // 符合去凑单项目
                result = 'app://DMAddOnItemPage?' + uri.split('?')[1];
            } else if (_fn.isSmartCart(uri, param)) { // 符合智能购物车
                var paramStr = uri.split('?')[1] || '';
                paramStr = paramStr && paramStr.replace('redirectType=', 'redirectBiz='); //修改redirectType 参数key避免重复跳转
                galleon.Navigator.replace(env + smartcartUrl + paramStr, '');
                result = 'pixie:stop';
            } else if (_fn.isMiniprogram(uri, param) && param.type * 1 == 3) { // 处理小程序扫码问题
                var paramStr = uri.split('?')[1];
                //console.log( 'https://static.dmall.com/kayak-project/h5/html/2017/smartcart.html?dmShowShare=false&dmShowCart=false&' + paramStr );
                galleon.Navigator.replace(env + smartcartUrl + paramStr, '');
                result = 'pixie:stop';
            }

            result = result || uri;
            return result;
        },
        getENV: function (uri) { //获取环境
            var env = 'https://';
            if (uri.indexOf('//test') > 0 || uri.indexOf('env=test') > 0) {
                env = 'https://test';
            } else if (uri.indexOf('//dev') > 0 || uri.indexOf('env=dev') > 0) {
                env = 'https://dev'
            }
            return env;
        },
        parseRNUri: function (uri) {
            var result;
            if (uri.indexOf('rn://') == 0) { //如果是以rn 协议打头的地址
                galleon.Navigator.forward(uri, '');
                return 'pixie:stop';
            } else { // 否则 不处理
                return uri;
            }
        },
        /**
         *
         * @param {*} uri
         * @param {*} param
         * 包括 餐食码 与 快剪码
         */
        isStallPos: function (uri) {
            // 目前 采用灵活方案 来处理
            // 后续根据反馈来处理是否要做 严格校验
            if (
                // uri.indexOf('stallpos.wumart.com/stall/redirec') > 0 &&
                uri.match(/^(http:\/\/|https:\/\/|\/\/)\w*stallpos.wumart.com\/\w*\/redirec\?/)
                // param.stallNo && param.orgNo && param.regionNo
            ) {
                return true
            }
            return false
        },
        getStallCode: function (uri, param) {
            param = param || {};
            if (!_fn.isStallPos(uri)) {
                return param;
            }
            var mapArr = uri.split('?')[0].split('/');
            param.businessKey = mapArr[3] || '';
            return param;
        },
        isCoudan: function (uri, param) {
            var redirectType = param.redirectType || '',
                targetVersion = param.redirectVersion || '';

            targetVersion = targetVersion.replace(/_/g, '.');
            if (_fn.versionIsBig(sysInfo.version, targetVersion) && param.redirectType == 'coudan') {
                return true;
            }
            return false;
        },
        isSmartCart: function (uri, param) {
            var redirectType = param.redirectType || '',
                targetVersion = param.redirectVersion || '';

            targetVersion = targetVersion.replace(/_/g, '.');
            if (_fn.versionIsBig(sysInfo.version, targetVersion) && param.redirectType == 'smartcart') {
                return true;
            }
            return false;
        },

        isMiniprogram: function (uri, param) { // 不考虑情况
            if (uri.indexOf('static.dmall.com/mini/') > -1) {
                return true;
            }
            return false;
        },

        isNormalDshopUri: function (uri, param) {
            // 已经被处理过的参数，有时要考虑死循环问题
            if (uri.indexOf('a.dmall.com') > -1 && (param.dmShowCart + '') == 'false' && (param.dmShowShare + '') == 'false') {
                return false;
            }
            return true;
        },

        // 对比版本，如果第一个大于 等于 第二个参数则反true否则反false
        versionIsBig: function (first, second) {
            first = first || '';
            second = second || '';
            var len, i;

            first = first.split('.');
            second = second.split('.');
            if (first.length == 0 && second.length > 0) {
                return false;
            }
            if (first.length > 0 && second.length == 0) {
                return true;
            }
            if (first.length == 0 && second.length == 0) {
                return false;
            }

            len = first.length >= second.length ? first.length : second.length;
            for (i = 0; i < len; ++i) {
                if ((first[i] || 0) * 1 > (second[i] || 0) * 1) {
                    return true;
                } else if ((first[i] || 0) * 1 < (second[i] || 0) * 1) {
                    return false;
                }
            }
            return true; // 全等于的情况
        },
        getUrlParam: function (parmUrl, name) {
            parmUrl = parmUrl || window.location.href;
            name = name || '';
            var loc = parmUrl.split('?'),
                search = loc[1] || '',
                url = '',
                result, i, s;

            search = search.split('#')[0] || '';
            search = search.split('&');
            if (name) {
                var reg = new RegExp('(^|&)' + name + '=([^&]*)(&|$)', 'i'),
                    r = (loc[1] || '').match(reg),
                    type = r ? decodeURIComponent(r[2]) : '';
                result = type.split('#')[0] || '';
            } else {
                result = {};
                for (i = 0; s = search[i]; ++i) {
                    s = s.split('=');
                    if (s.length == 2) {
                        result[s[0]] = s[1];
                    }

                }
            }
            return result;
        },
        paramToObj: function (str) {
            str = str || '';
            var result = {},
                list = str.split('&'),
                p, i, len;

            for (i = 0, len = list.length; i < len; ++i) {
                p = (list[i] + '').split('=');
                if (p.length != 2) {
                    continue;
                }
                result[p[0]] = p[1];
            }
            return result;
        },
        parseParam: function (param, concatChar) {
            param = param || [];
            concatChar = concatChar || '?';
            var paramStr = [], key;
            for (key in param) {
                paramStr.push(key + '=' + encodeURIComponent(param[key]));
                // paramStr.push( key + '=' + encodeURIComponent(param[key]) );
                // paramStr.push( key + '=' + param[key] );
            }

            paramStr = paramStr.join('&');
            return paramStr == '' ? '' : concatChar + paramStr;
        },
    }

    //var result = handle.parseScanUri('https://a.dmall.com/act/wFkq0RQDl1ti.html?erpStoreId=230&dmfrom=wx&from=wx&shareKey=1524467832738');
    //console.log( result );
    window.pixie = handle;
})();
